/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.43 from the
 * contents of XS.xs. Do not edit this file, edit XS.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "XS.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#define PI (3.141592653589793)

double
haversine_distance_rad(double lat1, double lon1, double lat2, double lon2) {
  double smlat = sin((lat1 - lat2) / 2.0);
  double smlon = sin((lon1 - lon2) / 2.0);
  double a = smlat * smlat + cos(lat1) * cos(lat2) * smlon * smlon;
  return 6371640 * 2 * atan2(sqrt(a), sqrt(1 - a));
}

double
haversine_distance_dec(double lat1, double lon1, double lat2, double lon2) {
  return haversine_distance_rad(
    lat1 * (PI / 180.0),
    lon1 * (PI / 180.0),
    lat2 * (PI / 180.0),
    lon2 * (PI / 180.0)
  );
}

double*
data_from_av(AV* list) {
  double* data;
  I32 len = av_len(list);
  I32 ix;
  
  Newxz(data, (len + 1)*6, double);
  
  if (data == NULL) {
    return NULL;
  }

  for (ix = 0; ix <= len; ++ix) {
    SV** value = av_fetch(list, ix, 0);
    SV* rv;
    AV* entry;
    I32 entry_len;
    I32 ex;
    I32 dx = ix * 6;

    if (!value || !*value || !SvROK(*value))
      continue;

    rv = SvRV(*value);

    if (!rv || !(SvTYPE(rv) == SVt_PVAV))
      continue;

    entry = (AV*)rv;
    entry_len = av_len(entry);

    /* Must have two or three entries */
    if (entry_len < 1 || entry_len > 2) {
      warn("bad item in points list");
      continue;
    }

    /* default for weight */
    data[ dx + 2 ] = 1.0;

    for (ex = 0; ex <= entry_len && ex < 3; ++ex) {
      SV** item = av_fetch(entry, ex, 0);
      
      if (!item || !*item) {
        continue;
      }

      data[ dx + ex ] = SvNV(*item);
    }

    data[ dx + 0 ] *= (PI / 180.0);                         /* lat in rad */
    data[ dx + 1 ] *= (PI / 180.0);                         /* lon in rad */
                                                            /* weight     */
    data[ dx + 3 ] = cos(data[ dx ]) * cos(data[ dx + 1 ]); /* x          */
    data[ dx + 4 ] = cos(data[ dx ]) * sin(data[ dx + 1 ]); /* y          */
    data[ dx + 5 ] = sin(data[ dx ]);                       /* z          */
  }

  return data;
}

int
median_center(HV* opts, double* plat, double* plon) {

  U32 max_iterations = 4;
  double tolerance = 0.0f;
  SV** value;
  double* data = NULL;
  double clat = 0;
  double clon = 0;
  I32 count = 0;

  if (opts == NULL || !( SvTYPE(opts) == SVt_PVHV )) {
    return -1;
  }

  value = hv_fetch(opts, "points", 6, 0);

  if (value && *value && SvROK(*value)) {
    SV* rv = SvRV(*value);

    count = av_len((AV*)rv);
    if (rv && (SvTYPE(rv) == SVt_PVAV) && count >= 0) {
      data = data_from_av((AV*)rv);
    }
  }

  value = hv_fetch(opts, "tolerance", 9, 0);

  if (value && *value && SvOK(*value)) {
    tolerance = SvNV(*value);
  }

  value = hv_fetch(opts, "max_iterations", 14, 0);

  if (value && *value && SvOK(*value)) {
    max_iterations = SvUV(*value);
  }

  while (data) {

    double sumkx, sumky, sumkz, sumk, avgx, avgy, avgz, nlat, nlon, ndst;
    size_t last = (count + 1) * 6;
    size_t ix;

    sumkx = sumky = sumkz = sumk = 0;

    for (ix = 0; ix < last;) {
      double lat = data[ix++];
      double lon = data[ix++];
      double wgt = data[ix++];
      double dst = haversine_distance_rad(clat, clon, lat, lon);
      double wgd;

      if (dst == 0) {
        dst = DBL_EPSILON;
      }

      wgd = wgt / dst;

      sumkx += wgd * data[ix++];
      sumky += wgd * data[ix++];
      sumkz += wgd * data[ix++];
      sumk  += wgd;
    }
    
    avgx = sumkx / sumk;
    avgy = sumky / sumk;
    avgz = sumkz / sumk;

    /* Should this rather use asin(avgz)? */
    nlat = atan2(avgz, sqrt(avgx * avgx + avgy * avgy));
    nlon = atan2(avgy, avgx);

    ndst = haversine_distance_rad(clat, clon, nlat, nlon);

    if (!(max_iterations-- > 0) || (ndst <= tolerance)) {
      *plat = nlat * (180.0 / PI);
      *plon = nlon * (180.0 / PI);

      Safefree(data);
      
      return 0;
    }

    clat = nlat;
    clon = nlon;
  }

  /* If we get here, there was an error retrieving the points */
  return -1;
}

#line 188 "XS.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 332 "XS.c"

XS_EUPXS(XS_Geo__MedianCenter__XS_haversine_distance_rad); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Geo__MedianCenter__XS_haversine_distance_rad)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "lat1, lon1, lat2, lon2");
    {
	double	RETVAL;
	dXSTARG;
	double	lat1 = (double)SvNV(ST(0))
;
	double	lon1 = (double)SvNV(ST(1))
;
	double	lat2 = (double)SvNV(ST(2))
;
	double	lon2 = (double)SvNV(ST(3))
;

	RETVAL = haversine_distance_rad(lat1, lon1, lat2, lon2);
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Geo__MedianCenter__XS_haversine_distance_dec); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Geo__MedianCenter__XS_haversine_distance_dec)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "lat1, lon1, lat2, lon2");
    {
	double	RETVAL;
	dXSTARG;
	double	lat1 = (double)SvNV(ST(0))
;
	double	lon1 = (double)SvNV(ST(1))
;
	double	lat2 = (double)SvNV(ST(2))
;
	double	lon2 = (double)SvNV(ST(3))
;

	RETVAL = haversine_distance_dec(lat1, lon1, lat2, lon2);
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Geo__MedianCenter__XS_median_center); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Geo__MedianCenter__XS_median_center)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "opts");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	HV*	opts;
#line 193 "XS.xs"
    double lat = 0.0f;
    double lon = 0.0f;

#line 398 "XS.c"

	STMT_START {
		SV* const xsub_tmp_sv = ST(0);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    opts = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Geo::MedianCenter::XS::median_center",
				"opts");
		}
	} STMT_END
;
#line 197 "XS.xs"
    if (median_center(opts, &lat, &lon))
      XSRETURN_EMPTY;

    mXPUSHs(newSVnv( lat ));
    mXPUSHs(newSVnv( lon ));
#line 419 "XS.c"
	PUTBACK;
	return;
    }
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Geo__MedianCenter__XS); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Geo__MedianCenter__XS)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Geo::MedianCenter::XS::haversine_distance_rad", XS_Geo__MedianCenter__XS_haversine_distance_rad);
        newXS_deffile("Geo::MedianCenter::XS::haversine_distance_dec", XS_Geo__MedianCenter__XS_haversine_distance_dec);
        newXS_deffile("Geo::MedianCenter::XS::median_center", XS_Geo__MedianCenter__XS_median_center);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

